function ProgressBar(){
	var _this = this;
	var elementDiv = $('.circle-progress-bar');
	var horizontalProgressDiv = $('.horizontal-progress-div');

	_this.createHtml = function(_el){
		var el = _el || elementDiv;
		
		var str = '';

		str += '<div class="circle-wrap">';
			str += '<div class="circle">';
				str += '<div class="mask full">';
					str += '<div class="fill"></div>';
				str += '</div>';
				str += '<div class="mask half">';
					str += '<div class="fill"></div>';
				str += '</div>';
				str += '<div class="inside-circle">0%</div>';
			str += '</div>';
		str += '</div>';

		el.html(str);
		
	}
	_this.update = function(){
		var percentage = APP.courseDataObj.getCourseComPercentage();
		if(percentage < 0){percentage = 0}
		if(percentage > 100){percentage = 100}
		var angle = Math.round((percentage / 100 ) * 180);
		elementDiv = $('.circle-progress-bar');
		rotationUpdate(percentage, angle);
	}
	_this.rotationUpdate = function(_percentage, _angle, _el){
		var el = _el || elementDiv;	
		rotationUpdate(_percentage, _angle, el);
	}
	function rotationUpdate( _percentage, _angle, _el){	
		var el = _el || elementDiv;	
		el.find('.inside-circle').html(_percentage + '%');
		
		el.find('.circle .mask.full').css({			
			'transform': '-webkit-rotate(' + _angle + 'deg)',
			'transform': '-ms-rotate(' + _angle + 'deg)',
			'transform': 'rotate(' + _angle + 'deg)'
		});
		el.find('.circle .fill').css({			
			'transform': '-webkit-rotate(' + _angle + 'deg)',
			'transform': '-ms-rotate(' + _angle + 'deg)',
			'transform': 'rotate(' + _angle + 'deg)'
		});
	}

	/* ----------------Horizontal progressbar funtions ----------------------------*/

	_this.revertHorizontalProgressBar = function(){		
		$('.horizontal-progress-panel').append(horizontalProgressDiv);
	}
	_this.addHorizontalProgressBar = function(){
		if(APP.navData.moduleId != 0){			
			var pgObj = $('#screen-container').find('.screen-data');
			if(pgObj.length){
				pgObj.append(horizontalProgressDiv);
				_this.updateHorizontalProgressBar();
			}
		}
	}
	_this.updateHorizontalProgressBar = function(){		
		//var val = APP.courseDataObj.getTopicProgress(APP.navData.moduleId,APP.navData.topicId);
    	var val = APP.courseDataObj.getCourseComPercentage();
		horizontalProgressDiv.find('.curr-strip').css('width',val+'%');
		var wd = horizontalProgressDiv.find('.highlighter').width();
		//var vleft = 'calc('+val+'% - '+wd+'px)';
		
		horizontalProgressDiv.find('.highlighter').css('left',(val - 1)+'%');
		//horizontalProgressDiv.find('.highlighter').animate({left: "'"+vleft+"'"});
	}
	_this.resetHorizontalProgressBar = function(){		
		horizontalProgressDiv.find('.curr-strip').css('width','0%');
		horizontalProgressDiv.find('.highlighter').css('left','0%');
		
	}
	
}	
