function SideNavMenu() {
	var _this = this;
	var Selector = {};	
	var iconObj = Object.assign({}, APP.iconObj);
	var isVidPlaying = false;
	var isVidEnded = false;
	var isAudPlaying = false;
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_CONTAINER: '#sidenav_menu',
			XML_NODE: APP.globalXmlsObj.globalXML,
			FONT_ICON_CLASS_OBJ: {				
				plus: 'icon-plus',
				minus: 'icon-minus'
			},
			ON_INIT: null,
			ON_COMPLETE: null,
			ON_CLICK: null,
			isLoaded: false
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.hidePanel = function(){
		hidePanel();
	}
	function initTemplate() {
		APP.preloaderObj.show();
		if(Selector.XML_NODE == null){
			console.warn('XML NOT FOUND...')
			return;
		}
		
		Selector.isLoaded = false;
		APP.eventObj.sideNavMenuStatus(true);
		$(Selector.ACTIVITY_CONTAINER).html(getHtml());
		//--for responsive
		$('body').addClass('modal-open');
		//--
		createHeader();
		createContent();
		createFooter();
		addTemplateEvent();
		updateModButtonStatus();
		updateTopicButtonStatus();
		updateScreenButtonStatus();
		showPanel();
		APP.preloaderObj.hide();
	}
	function getHtml(){
		str ='';
		str += '<div class="side-panel">';
			str += '<div class="side-body">';
				str += '<div class="side-header">';				
				str += '</div>';
				str += '<div class="side-content custom-scroll color-1">';
					str += '<div class="scrollable"></div>';				
				str += '</div>';
				str += '<div class="side-footer">';				
				str += '</div>';
			str += '</div>';
		str += '</div>';
		return str;
	}
	function createHeader(){
		var obj = $(Selector.ACTIVITY_CONTAINER).find('.side-header');
		var str ='';
		/* str +='<div class="display-table header-table">';
			str +='<div class="display-cell header-cell title-cell font-1">';
				str += '<span class="txt">'+Selector.XML_NODE.commonText[0].sideNavTitle[0].Text+'</span>';
			str += '</div>';
			str +='<div class="display-cell header-cell close-btn-cell">';
				str += '<a class="btn transBg close-btn" href="javascript:void(0);" >';
					str += '<span class="btn-icon font-icon icon-cross display-cell v-center"></span>';
				str += '</a>';
			str += '</div>';
		str += '</div>'; */
		$(obj).html(str);
	}
	function createContent(){
		var obj = $(Selector.ACTIVITY_CONTAINER).find('.side-content .scrollable');
		var str ='';
		
		var menuXmlObj = Selector.XML_NODE.menu[0];
		
		for (var i=0; i<menuXmlObj.module.length; i++){
			
			var curr = menuXmlObj.module[i];
			if(curr.hideOnMenu == 'true'){
				continue;
			}
			var statusClass="not-attempted"
			var modStatus = APP.courseDataObj.getModuleStatus(i);
			if(modStatus == '1'){
				statusClass = "incomplete"
			}
			if(modStatus == '2'){
				statusClass = "complete"
			}
			var mref = 'mod-'+i;
			var mtxt = curr.title[0].Text;
			var visibleClass = '';
			if(mtxt == null || mtxt == ''){
				visibleClass = 'no-title'
			}
			
			var ntxt = curr.numText[0].Text;
			/* 1 */str += '<div id="'+mref+'" class="mod-btn-block '+mref+'  '+statusClass+' '+visibleClass+'">';
					str+='<a class="btn transBg module-btn font-medium" data-modid="'+i+'" href="javascript:void(0)">';
						
						str+= '<span class ="btn-txt pre-txt " >'+ntxt+'</span>';				
						str+= '<span class ="btn-txt  " >'+mtxt+'</span>';		
						str += '<div class="indicator indicator-cell "><div class="icon-bg11"><span class="font-icon icon"></span></div></div>';		
						/* str += '<div class="indicator indicator-cell "><span class="font-icon icon"></span></div>';	 */			
						/* str+= '<span class ="btn-icon font-icon plus-minus v-center display-cell '+Selector.FONT_ICON_CLASS_OBJ.plus+'" ></span>';		 */				
					str += '</a>';
			/* 1 */str += '</div>';
			//create sub topic
			/* 1a */str += '<div id="collapse-'+mref+'" class="collapse collapse-mod collapse-'+mref+' ">';
			var subTopicXmlObj = curr.topic;
			for (var j=0; j<subTopicXmlObj.length; j++){
				
				var currSubTopic = subTopicXmlObj[j];
				if(currSubTopic.hideOnMenu == 'true'){
					continue;
				}
				var subTopicStatusClass="not-attempted"
				var subTopicStatus = APP.courseDataObj.getTopicStatus(i, j);
				if(subTopicStatus == '1'){
					subTopicStatusClass = "incomplete"
				}
				if(subTopicStatus == '2'){
					subTopicStatusClass = "complete"
				}
				var tref = 'topic-'+i+'_'+j;
				var ttxt = currSubTopic.title[0].Text;
				var tvisibleClass = '';
				if(ttxt == null || ttxt == ''){
					tvisibleClass = 'no-title'
				}
				/* 2 */str += '<div id="'+tref+'" class="topic-btn-block '+tref+' '+subTopicStatusClass+' '+tvisibleClass+'">';
						str+='<a class="btn transBg topic-btn font-0" data-modid="'+i+'" data-topicid="'+j+'" href="javascript:void(0)">';
							str+= '<div class ="btn-txt " >'+ttxt+'</div>';
							str += '<div class="indicator indicator-cell "><div class="icon-bg11"><span class="font-icon icon"></span></div></div>';
							/* str+= '<span class ="btn-icon font-icon plus-minus '+Selector.FONT_ICON_CLASS_OBJ.plus+'" ></span>'; */	
						str += '</a>';
				/* 2 */str += '</div>';
				
			}
			/* 1a */str += '</div>';
			//topic end
		}
		
		//module end
		//--indicator div
		
		var inXmlObj = Selector.XML_NODE.commonText[0];
		str += '<div class="indicator-panel">';
			str += '<div class="indi-block">';
				str += '<div class="icon-cell"><span class="font-icon '+iconObj.locked+'"></span></div>';
				str += '<div class="txt-cell"><span class="i-t">'+inXmlObj.menuLockedTxt[0].Text+'</span></div>';
			str += '</div>';
			str += '<div class="indi-block">';
				str += '<div class="icon-cell"><span class="font-icon '+iconObj.notAttempted+'"></span></div>';
				str += '<div class="txt-cell"><span class="i-t">'+inXmlObj.menuUnlockedTxt[0].Text+'</span></div>';
			str += '</div>';
			str += '<div class="indi-block">';
				str += '<div class="icon-cell"><span class="font-icon '+iconObj.incomplete+'"></span></div>';
				str += '<div class="txt-cell"><span class="i-t">'+inXmlObj.menuInProgressTxt[0].Text+'</span></div>';
			str += '</div>';
			str += '<div class="indi-block">';
				str += '<div class="icon-cell"><span class="font-icon '+iconObj.complete+'"></span></div>';
				str += '<div class="txt-cell"><span class="i-t">'+inXmlObj.menuCompleteTxt[0].Text+'</span></div>';
			str += '</div>';
		str += '</div>';
		//--
		$(obj).html(str);
		
	}
	function createFooter(){
		//future development plan
	}

	function addTemplateEvent() {
		$(Selector.ACTIVITY_CONTAINER).find('.module-btn').on('click', function(e){
			var parentBlock = $(this).parents('.mod-btn-block');
			if(parentBlock.hasClass('locked') || $(this).hasClass('disabled')){return false;};
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			var id = parentBlock.attr('id');
			var modid = $(this).data('modid')
			var collapseObj = parentBlock.siblings('.collapse-'+id);
			//--if only 1 topic then direct load that screen
			var avlTopic = collapseObj.find('.topic-btn-block').length;
			if(avlTopic > 0){
				if(parentBlock.hasClass('open')){				
					collapseObj.find('.topic-btn-block').removeClass('open')
					collapseObj.find('.collapse-topic').slideUp('slow');
					collapseObj.slideUp('slow', function(){					
						parentBlock.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.minus).addClass(Selector.FONT_ICON_CLASS_OBJ.plus);
						collapseObj.find('.topic-btn-block').find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.minus).addClass(Selector.FONT_ICON_CLASS_OBJ.plus);
					});
					parentBlock.removeClass('open');
				}else{
					//if only one topic without title then direct show screens entry
					if(avlTopic == 1){
						/* collapseObj.show();	
						collapseObj.find('.collapse-topic').hide();
						collapseObj.find('.collapse-topic').eq(0).slideDown('slow'); */
						APP.navData.moduleId = modid;
						APP.navData.topicId = 0;
						APP.navData.screenId = 0;
						hidePanel(function (){
							APP.navigationObj.loadScreen();
						});
					}else{
						collapseObj.slideDown('slow', function(){
							//default open all topic
							//collapseObj.find('.collapse-topic').slideDown();
							//collapseObj.find('.topic-btn-block').addClass('open');
							//default open 1st topic
							//collapseObj.find('.collapse-topic').hide();
							//collapseObj.find('.collapse-topic').eq(0).slideDown();					
						});	
					}					
					parentBlock.addClass('open');
					parentBlock.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);			
				}
			}else{
				APP.navData.moduleId = modid;
				APP.navData.topicId = 0;
				APP.navData.screenId = 0;
				hidePanel(function (){
					APP.navigationObj.loadScreen();
				});
			}
			//--
			
		})
		$(Selector.ACTIVITY_CONTAINER).find('.topic-btn').on('click', function(e){
			var parentBlock = $(this).parents('.topic-btn-block');
			if(parentBlock.hasClass('locked') || $(this).hasClass('disabled')){return false;};	
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			var id = parentBlock.attr('id');
			var collapseObj = parentBlock.siblings('.collapse-'+id);
			//-- to check screen count
			var scrLen = collapseObj.find('.screen-btn').length;
			if(scrLen === 0){
				APP.navData.moduleId = $(this).data('modid');
				APP.navData.topicId = $(this).data('topicid');
				APP.navData.screenId = 0;
				hidePanel(function (){
					APP.navigationObj.loadScreen();
				});
			}else{
				if(parentBlock.hasClass('open')){
					collapseObj.slideUp('slow', function(){	
						parentBlock.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.minus).addClass(Selector.FONT_ICON_CLASS_OBJ.plus);			
					});	
					parentBlock.removeClass('open');
					
				}else{
					collapseObj.slideDown('slow', function(){				
					});	
					parentBlock.addClass('open');	
					parentBlock.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);
				}
			}
			//--		
			
		})
		$(Selector.ACTIVITY_CONTAINER).find('.screen-btn').on('click', function(e){
			if($(this).parents('.screen-btn-block').hasClass('locked') || $(this).hasClass('disabled')){return false;};	
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			APP.navData.moduleId = $(this).data('modid');
			APP.navData.topicId = $(this).data('topicid');
			APP.navData.screenId = $(this).data('screenid');
			hidePanel(function (){
				APP.navigationObj.loadScreen();
			});
			
		})
		$(Selector.ACTIVITY_CONTAINER).find('.close-btn').on('click', function(e){
			if($(this).hasClass('disabled')){return false;};
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			if(Selector.isLoaded){
				hidePanel();
			}
		})
		$(Selector.ACTIVITY_CONTAINER).off('click');
		$(Selector.ACTIVITY_CONTAINER).on('click', function(e){	
			
			if($(this).attr('class') == $(e.target).attr('class')){
				if(Selector.isLoaded){
					hidePanel();
				}
			}
		});
		/* $(Selector.ACTIVITY_CONTAINER).find('.side-content').off('click');
		$(Selector.ACTIVITY_CONTAINER).find('.side-content').on('click', function(e){
			e.stopPropagation();				
			if($(this).attr('class') == $(e.target).attr('class')){
				if(Selector.isLoaded){
					hidePanel();
				}
			}
		}); */
	}

	function updateModButtonStatus(){	
		var cheatMode = APP.configObj.cheatMode;	
		var menuContainer = $(Selector.ACTIVITY_CONTAINER).find('.side-content');
		//--custom for this course
		var isMod1Complete = APP.courseDataObj.isModuleComplete(1);
		var isMod2Complete = APP.courseDataObj.isModuleComplete(2);
		var isMod3Complete = APP.courseDataObj.isModuleComplete(3);

		if(APP.configObj.menu.lockMenu == true && !cheatMode){
			menuContainer.find('.mod-btn-block.not-attempted').addClass('locked');
			menuContainer.find('.mod-btn-block').eq(0).removeClass('locked');
			//menuContainer.find('.mod-btn-block.complete').next().removeClass('locked');
			if(isMod1Complete === true){
				menuContainer.find('.mod-2').removeClass('locked');
			}
			if(isMod1Complete === true && APP.courseDataObj.isAnyTopicComplete(2) === true){
				menuContainer.find('.mod-3').removeClass('locked');
			}
		}
		//--indicator changes
		menuContainer.find('.mod-btn-block.locked').find('.indicator .icon').addClass(iconObj.locked);
		menuContainer.find('.mod-btn-block.not-attempted:not(.locked)').find('.indicator .icon').addClass(APP.iconObj.notAttempted);
		menuContainer.find('.mod-btn-block.incomplete').find('.indicator .icon').addClass(iconObj.incomplete);
		menuContainer.find('.mod-btn-block.complete').find('.indicator .icon').addClass(iconObj.complete);
	}
	function updateTopicButtonStatus(){
		var cheatMode = APP.configObj.cheatMode;
		var isMod1Complete = APP.courseDataObj.isModuleComplete(1);
		var subMenuContainer = $(Selector.ACTIVITY_CONTAINER).find('.side-content');
		if(APP.configObj.menu.lockSubMenu == true && !cheatMode){
			subMenuContainer.find('.topic-btn-block.not-attempted').addClass('locked');			
			subMenuContainer.find('.topic-btn-block').eq(0).removeClass('locked');
			subMenuContainer.find('.mod-btn-block.locked').next('.collapse-mod').find('.topic-btn-block').eq(0).addClass('locked');			
			subMenuContainer.find('.topic-btn-block.complete').next().removeClass('locked');
			if(isMod1Complete == true){
				subMenuContainer.find('.collapse-mod-2').find('.topic-btn-block').removeClass('locked');
			}
		}
		
		//--indicator changes
		subMenuContainer.find('.topic-btn-block.locked').find('.indicator .icon').addClass(iconObj.locked);
		subMenuContainer.find('.topic-btn-block.not-attempted:not(.locked)').find('.indicator .icon').addClass(APP.iconObj.notAttempted);
		subMenuContainer.find('.topic-btn-block.incomplete').find('.indicator .icon').addClass(iconObj.incomplete);
		subMenuContainer.find('.topic-btn-block.complete').find('.indicator .icon').addClass(iconObj.complete);
		
	}
	function updateScreenButtonStatus(){
		var cheatMode = APP.configObj.cheatMode;
		var subMenuContainer = $(Selector.ACTIVITY_CONTAINER).find('.side-content');
		if(APP.configObj.menu.lockSubMenu == true && !cheatMode){
			subMenuContainer.find('.screen-btn-block.not-attempted').addClass('locked');
			subMenuContainer.find('.screen-btn-block').eq(0).removeClass('locked');	
			subMenuContainer.find('.topic-btn-block.locked').next('.collapse-topic').find('.screen-btn-block').eq(0).addClass('locked');		
			subMenuContainer.find('.screen-btn-block.complete').next().removeClass('locked');
		}
		
		//--indicator changes
		subMenuContainer.find('.screen-btn-block.locked').find('.indicator .icon').addClass(iconObj.locked);
		subMenuContainer.find('.screen-btn-block.not-attempted:not(.locked)').find('.indicator .icon').addClass(iconObj.notAttempted);
		subMenuContainer.find('.screen-btn-block.incomplete').find('.indicator .icon').addClass(iconObj.incomplete);
		subMenuContainer.find('.screen-btn-block.complete').find('.indicator .icon').addClass(iconObj.complete);
		
	}
	function showPanel(){	
		//--pause video and audio
		if(APP.vidPlayer){
			isVidPlaying = !(APP.vidPlayer.paused);
			isVidEnded = (APP.vidPlayer.ended);
			if(isVidPlaying && !isVidEnded){
				//video is playing so stop them
				APP.vidPlayer.pause();
			}
		}			
		if(APP.screenAudio){isAudPlaying = APP.screenAudio.playing() || false;}		
		
		if(isAudPlaying){APP.screenAudio.pause();}
		
		//--	
		//--default expand current screen row
		var currModObj = $(Selector.ACTIVITY_CONTAINER).find('#mod-'+APP.navData.moduleId);
		var currTopicObj = $(Selector.ACTIVITY_CONTAINER).find('#topic-'+APP.navData.moduleId+'_'+APP.navData.topicId);
		var currScreenObj = $(Selector.ACTIVITY_CONTAINER).find('#screen-'+APP.navData.moduleId+'_'+APP.navData.topicId+'_'+APP.navData.screenId);
		currModObj.addClass('current');
		currTopicObj.addClass('current');
		currScreenObj.addClass('current');
		var mid = currModObj.attr('id');
		var tid = currTopicObj.attr('id');
		
		/* var mcollapseObj = currModObj.siblings('.collapse-'+mid);
		currModObj.addClass('open');
		currModObj.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);
		mcollapseObj.show();

		var tcollapseObj = currTopicObj.siblings('.collapse-'+tid);
		currTopicObj.addClass('open');
		currTopicObj.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);
		tcollapseObj.show(); */
 
		//to open all
		$(Selector.ACTIVITY_CONTAINER).find('.mod-btn-block').addClass('open');
		$(Selector.ACTIVITY_CONTAINER).find('.collapse-mod').show();
		
		//---
		//---remove module and direct show topic if module length = 1
		var showModCount = APP.navigationObj.getActualModuleCount();
		if(showModCount <= 1){
			var firstMod = $(Selector.ACTIVITY_CONTAINER).find('.mod-btn-block').eq(0);			
			firstMod.addClass('current open').hide();
			firstMod.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);
			var colObj = firstMod.siblings('.collapse-mod');
			colObj.show();
			colObj.find('.topic-btn-block').addClass('open');
			colObj.find('.collapse-topic').show();
			colObj.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);
		}
		$(Selector.ACTIVITY_CONTAINER).fadeIn('slow');
		//--slide main-div 		
		//$('#main-div').addClass('ani-slide');
		//custom edit for client remove side animation
		/* APP.animationObj.animate({
			EL: $('#main-div'),
			TYPE: 'margin-left',
			START_VAL: '-30%',
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				
			}
		}); */
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find('.side-panel'),
			TYPE: 'fade-in-right',
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				Selector.isLoaded = true;
				$(this.target).focus();
			}
		});
		
	}	
	function hidePanel(callback){	
		Selector.isLoaded = false;	
		APP.sideNavMenu = null;	
		//--for responsive
		$('body').removeClass('modal-open');
		//--	
		//$('#main-div').removeClass('ani-slide');
		//custom edit for client remove side animation
		/* APP.animationObj.animate({
			EL: $('#main-div'),
			TYPE: 'margin-left',
			START_VAL: '0%',
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				
			}
		});	 */
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find('.side-panel'),
			TYPE: 'fade-out-right',
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				
			}
		});
		
		$(Selector.ACTIVITY_CONTAINER).fadeOut(500, function(){
			$(Selector.ACTIVITY_CONTAINER).hide().html('');
			APP.eventObj.sideNavMenuStatus(false);
			if(APP.vidPlayer){
				if(isVidPlaying && !isVidEnded){
					//video is playing so play them again 
					APP.vidPlayer.play();	
								
				}
			}
			if(isAudPlaying){APP.screenAudio.play();}
			if(callback){
				callback();
			}
		});	
	}
	function updateTemplateLayout() {}
	
	$(document).on(APP.eventObj.ON_CUSTOM_RESIZE, function (e) {
		updateTemplateLayout();
	});
}